#!/usr/bin/perl -T
#$Id: PID_slow_control.pl,v 1.15 2016/05/27 13:25:02 sqko Exp $
use strict;
use warnings;
use RFC::Rig;
use SemaforeFile;
use RFC::Visitor;
die "No rig specified!\n" unless (@ARGV);
my $v = RFC::DisableProglogVisitor->new();
my $r = shift;
if ($r && $r =~ /(\d+)/)
{
    $r = $1;
}
else
{
    exit;
}
sleep(10);
my $file = '/tmp/dummy.txt';
my $lockfile = '/home/celltest/PID_slow_Rig_'.$r;
my $lock = SemaforeFile->new($file,$lockfile);
### Only allow one instance for each rig! ###
exit unless ($lock->lock_ex_nb());
my $rig = RFC::Rig->new($r);
$rig->check_run;
$rig->Accept($v);
foreach my $name ($rig->list_devices('PID'))
{
    my $d = $rig->get_device('PID',$name);
    next if (!defined($d) || $d->fast); ## only handle the slow devices ##
    $d->control();
    $d->store();
}
$rig->DESTROY();


