#!/usr/bin/perl -T
# $Id: logbook.cgi,v 1.6 2013/03/22 09:27:18 sqko Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Soeren Koch                 ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2011              ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use RFC::Main;
use RFC::Rig;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;
use CGI qw(:standard :netscape);
use SemaforeFile;

my $r = param('rig');
unless ($r)
{
    print header();
    print "No rig specified!\n";
    exit;
}
my $rig = RFC::Rig->new($r);

if (!defined(param))
{
    &print_header("Please log in to the $name");
    print '<center>';
    RFC::RFCCGI::login();
    print '</center>';
    &print_end;
}
else
{
    #### husk at aendre accessparameter til det relevante for scriptet!! ####
    if (&login_ok())
    { 
        &print_header("Logbook for rig ".$rig->name);
        print RFC_start_html(-title=>"Rig ".$rig->name." logbook", -style=>{src=>'/celltest/RFCcontrol.css'});
        top_nav_bar_start;
	top_no_button;
	top_no_button;
	top_no_button;
	tab_newrow;
        if (&get_CGI_value_clean('action'))
        {
            top_no_button;
        }
        else
        {
            &js_back();
            top_js_return('#006600','white');
        }
	top_no_button;
	top_no_button;
        top_nav_bar_button('rig_main.cgi','','','To rig'.$rig->name.' main page','s3','rig,'.$rig->name.',1');
	top_nav_bar_button('main.cgi','','','To menu','s4');
	end_top_bar;
        param(-name=>'action',-value=>'')  unless (defined(param('action')));
	$_ = param('action');
      CASE:
	{
	    ### Insert case statements ###
	    /^Save/ and do {&save; &insert_data_form(); last CASE;};
	    ### Default response ####
    	    &insert_data_form;
	}	
	print_end;
    }
    else 
    {
	&not_auth;
    }
}
    
exit;

sub save
{
    my $logall = &get_CGI_value('log_all');
    my $string = &get_CGI_value('text');
    my $time = localtime;
    my $user = get_user();
    my $str = $time.": User $user added:\n".$string."\n\n";
    eval
    {
	foreach my $rigname (&RFC::Main::get_rigs())
	{
	    my $r = RFC::Rig->new($rigname);
	    next unless ($logall || $r->name == $rig->name);
	    my $f = $RFC::Header::publicdir.'rig'.$r->name.'/logbook.txt';
	    my $l = $r->riglock; 
	    my $file = SemaforeFile->new($f,$l);
	    my $test = $r->session;
	    $f = $RFC::Header::publicdir.'rig'.$r->name.'/'.$r->name.'test'.$test.'/info.txt';
	    my $info = SemaforeFile->new($f,$l);
	    $file->append($str);
	    $info->append($str);
	}
    };
    if ($@)
    {
	&errorlog($@);
	&print_error();
    }
}



sub insert_data_form
{
    my $f = $RFC::Header::publicdir.'rig'.$rig->name.'/logbook.txt';
    my $l = $rig->riglock; 
    my $file = SemaforeFile->new($f,$l);
    my $test = $rig->session;
    $f = $RFC::Header::publicdir.'rig'.$rig->name.'/'.$rig->name.'test'.$test.'/info.txt';
    my $info = SemaforeFile->new($f,$l);
    my $str = join("\n",$file->readlines);
    print start_form(-name=>'sofc',-class=>"form");
    &print_hidden_rig;  
    print '<center>';
    print '<table border=0 cellspacing=5 cellpadding=0 style="width:100%"><tr height=20>';
    print '<td width="10%"></td>';
    print '<td width="40%"></td>';
    print '<td width="40%"></td>';
    print '<td width="10%"></td>';
    print '</tr>';
    print '<tr><td colspan=4 class="heading">';
    print "Logbook for rig ".$rig->name;
    print '</td></tr>';
    print '<tr><td height=20></td></tr>';
    print '<tr><td></td><th valign=top>';
    print textarea(-name=>'test',-value=>$str,-class=>'textfield',-rows=>'30',-force=>'1');
    print '</th><th valign=top>';
    print checkbox(-name=>'log_all',-checked=>0,-force=>1,-label=>'Add to logbook for all rigs on this server');
    print textarea(-name=>'text',-value=>'',-class=>'textfield',-rows=>'26',-force=>'1');
    &menu_button('action','Save new entry','s3');
    print '</th></tr></table>';
    print end_form();
}

